unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX, IniFiles;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

function GetsysParam(muserId: pchar; fparam1: pchar): Boolean;

implementation

uses
  U_DataLink, U_iniParam, U_TradeGreyClothInList, U_TradeGreyClothOutList,
  U_TradeGreyClothStkList, U_TradeFtyClothInList, U_TradeFtyClothOutList,
  U_TradeFtyClothStkList, U_TradeFinishClothInList, U_TradeFinishClothOutList,
  U_TradeClothOutInspList, U_TradeFinishClothStkList, U_TradePackClothInList,
  U_TradePackClothOutList, U_TradePackClothStkList, U_TradeSampleClothInList,
  U_TradeSampleClothOutList, U_TradeSampleClothStkList, U_ClothPurchaseEnterList,
  U_ClothScheduleList, U_TradeClothTotalStkList, U_TradeClothTotalInList,
  U_TradeClothTotalOutList, U_TradeDeliveryRequest, U_TradeRRList,
  U_PlanScanInEdit, U_ItemizedListList, U_TradeXinYuStkList, U_TradeXinYuOutList,
  U_TradeXinYuTHStkList, U_TradeXinYuOutTHList, U_PlanScanInEdit2,
  U_PlanScanInEdit3;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  SetLength(fDllFileName, 255);
  GetModuleFileName(HInstance, PChar(fDllFileName), Length(fDllFileName));
  fDllFileName := ExtractFileName(PChar(fDllFileName));
  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  if trim(DataBaseStr) = '' then
  begin
    server := '101.132.143.144,7781';
    dtbase := 'gemeiData';
    user := 'rtsa';
    pswd := 'rightsoft@5740';

    DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
    Parameters1 := '管理';
    Parameters2 := '贸易布匹';
    Parameters2 := '格美门店';
    Parameters2 := '新余';
    DName := 'ADMIN';
    DCode := 'ADMIN';
  end
  else
  begin
    DConString := DataBaseStr;
  end;

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;
  if IsINIFile() then
    ReadINIFile()
  else
    WriteINIFile;
  GetsysParam('', '');
   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  bFound := False;
  if FormID <> 10000 then
  begin
    for i := 0 to Application.MainForm.MDIChildCount - 1 do
    begin
      if Application.MainForm.MDIChildren[i].Caption = Title then
      begin
        mnewHandle := Application.MainForm.MDIChildren[i].Handle;
        Application.MainForm.MDIChildren[i].BringToFront;
        bFound := True;
        Result := mnewHandle;
        exit;
      end;
    end;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of

    911: //采购回仓
      begin
        with TfrmClothPurchaseEnterList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;

    912: //面料生产安排
      begin
        with TfrmClothScheduleList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;

    920: //码单登记
      begin
        with TfrmItemizedListList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;

    921:  //贸易布匹入库
      begin
//        Parameters2 := '新余';
        with TfrmTradeClothTotalInList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;
    9211:  //贸易布匹入库
      begin
        Parameters2 := '新余零售';
        with TfrmTradeClothTotalInList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;
    221:  //退货申请
      begin
        with TfrmTradeRRList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;

    211:  //发货申请
      begin
        with TfrmTradeDeliveryRequest.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;

    922:  //贸易布匹出库
      begin
        with TfrmTradeClothTotalOutList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;

    923:  //贸易布匹库存
      begin
        with TfrmTradeClothTotalStkList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;

    924:  //新余库存
      begin
        with TfrmTradeXinYuStkList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;

    9241:  //新余零售库存
      begin
        with TfrmTradeXinYuthStkList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;
    925:  //新余出库
      begin
        with TfrmTradeXinYuOutList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;
    9251:  //新余出库
      begin
        with tfrmTradeXinYuOutTHList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;
    511:  //样布入库
      begin
        with TfrmTradeSampleClothInList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          FSTKName := '贸易样布';
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;

    521:  //样布出库
      begin
        with TfrmTradeSampleClothOutList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          FSTKName := '贸易样布';
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;

    531:  //样布库存
      begin
        with TfrmTradeSampleClothStkList.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
          FSTKName := '贸易样布';
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;
    666:  //上车扫码
      begin
        with TfrmPlanScanInEdit.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
//          FSTKName := '贸易样布';
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;
    667:  //出车扫码
      begin
        with TfrmPlanScanInEdit2.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
//          FSTKName := '贸易样布';
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;
    668:  //回单
      begin
        with TfrmPlanScanInEdit3.Create(Application.MainForm, Title, trim(Parameters1), trim(Parameters2), trim(Parameters3), trim(Parameters4), trim(Parameters5), trim(Parameters10), FormID, Title) do       //
        begin
//          FSTKName := '贸易样布';
          fFormID := FormID;
          WindowState := mstate;
          mnewHandle := Handle;
        end;
      end;
    10000:
      begin
        for i := 0 to application.MainForm.MDIChildCount - 1 do
        begin
          if application.MainForm.MDIChildren[i].Caption = Title then
          begin
            application.MainForm.MDIChildren[i].Close;
          end;
        end;
      end;
  end;

  Result := mnewHandle;
end;

function GetsysParam(muserId: pchar; fparam1: pchar): Boolean;
begin
  result := true;
  //////////////////////////////
//  shortDateFormat := 'yyyy-MM-dd';
  //服务器日期
  with DataLink_TradeTotalClothStk.AdoDataLink do
  begin
    close;
    sql.Clear;
    sql.Add('select getDate()as dt');
    open;
    DServerDate := fieldByName('dt').AsDatetime;
  end;
  result := true;
end;

//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
var
  IniFile: TIniFile;
begin
  try
    IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'SYSTEMSET.INI');
    PicSvr := IniFile.ReadString('SERVER', '服务器地址', '127.0.0.1');
    UserDataFlag := IniFile.ReadString('SERVER', '服务器地址类型', '-1');
  finally
    IniFile.Free;
  end;
  if not Assigned(DataLink_TradeTotalClothStk) then
    DataLink_TradeTotalClothStk := TDataLink_TradeTotalClothStk.Create(Application);
  try
    with DataLink_TradeTotalClothStk.ADOLink do
    begin
      if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_TradeTotalClothStk.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

